# 1 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!--------------------------------------------------------------------------------------------------!
!   CP2K: A general program to perform molecular dynamics simulations                              !
!   Copyright 2000-2022 CP2K developers group <https://cp2k.org>                                   !
!                                                                                                  !
!   SPDX-License-Identifier: GPL-2.0-or-later                                                      !
!--------------------------------------------------------------------------------------------------!

# 1 "/builddir/build/BUILD/cp2k-2023.1/src/xc/../common/cp_linked_list.fypp" 1
# 7 "/builddir/build/BUILD/cp2k-2023.1/src/xc/../common/cp_linked_list.fypp"
# 610 "/builddir/build/BUILD/cp2k-2023.1/src/xc/../common/cp_linked_list.fypp"
# 9 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F" 2

MODULE cp_linked_list_xc_deriv
   USE xc_derivative_types, ONLY: xc_derivative_type, xc_derivative_p_type
#include "../base/base_uses.f90"

# 52 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief describes a generic linked list template.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      Linked list are supposed to always use pointers to the nodes for
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      basically everything: a pointer to the node is a list, an element of
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      the list, an iterator between the elment of the list.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      An empty list is represented by an unassociated pointer.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      1.2002 created
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      4.2002 changed most of the methods, by making access to the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>             always through pointers (identifying pointer, list and iterators)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      6.2004 removed %initialized from list elements
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      IMPLICIT NONE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      PRIVATE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      LOGICAL, PRIVATE, PARAMETER :: debug_this_module = .TRUE.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!API type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         PUBLIC :: cp_sll_xc_deriv_type, cp_sll_xc_deriv_p_type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!API common methods
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      PUBLIC :: cp_create, cp_dealloc, cp_next
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!API special get
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      PUBLIC :: cp_get_first_el, cp_get_rest, cp_get_length, cp_get_element_at, cp_to_array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!API special set
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      PUBLIC :: cp_set_element_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!API structure manipulation
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      PUBLIC :: cp_insert, cp_remove_first_el, cp_remove_el, cp_remove_all
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      !API underlying routines
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         PUBLIC :: cp_sll_xc_deriv_create, cp_sll_xc_deriv_dealloc, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_next, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_get_length, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_get_el_at, cp_sll_xc_deriv_set_el_at, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_get_first_el, cp_sll_xc_deriv_get_rest, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_insert_el, cp_sll_xc_deriv_insert_el_at, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_rm_first_el, cp_sll_xc_deriv_rm_el_at, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_rm_all_el, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                   cp_sll_xc_deriv_to_array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! creation of an object (from a pointer)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_create
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_create
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! destruction of an object (from a pointer)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_dealloc
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_dealloc
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! iterates to the next element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_next
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_next
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! returns the first element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_get_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_get_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! returns the rest of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_get_rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_get_rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! returns the length of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_get_length
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_get_length
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! returns the element at the given position
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_get_element_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_get_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! sets the element at the given position
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_set_element_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_set_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! inserts one element call cp_insert(list,element,...)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_insert
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_insert_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_insert_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_insert_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! removes an element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_remove_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_rm_first_el, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               cp_sll_xc_deriv_rm_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! removes the first el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_remove_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_rm_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! remove all the elements
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_remove_all
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            MODULE PROCEDURE cp_sll_xc_deriv_rm_all_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! transorms the list in array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      INTERFACE cp_to_array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            module procedure cp_sll_xc_deriv_to_array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      END INTERFACE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief represent a single linked list that stores pointers to the elements
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param first_el the element that is stored in this node.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param rest the rest of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param empty true if the list pointer is not associated, if it points to
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>             to a not it is always false (as there is at least the
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>             first_el in the list)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param length the number of elements in the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      List are alway accessed through pointers, so every node of the
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      linked list can be seen as a list, its first element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      a pointer to the position before itself, in a very natural way:
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      all the insertions take place before the actual element, and
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      you still can insert an element at the end.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      This way I could identify nodes, lists and pointers between the
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      elements of the list.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      Indexing is 1 based.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         TYPE cp_sll_xc_deriv_type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER :: first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END TYPE cp_sll_xc_deriv_type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief pointer to a linked list (to make arrays of pointers)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param list the pointer to the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         TYPE cp_sll_xc_deriv_p_type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END TYPE cp_sll_xc_deriv_p_type
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      CONTAINS
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
      ! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief private compare function
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param el1 ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param el2 ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         function cp_sll_deriv_less_q(el1, el2) result(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            type(xc_derivative_type), INTENT(IN) :: el1, el2
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            logical :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            integer :: i
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            res = size(el1%split_desc) < size(el2%split_desc)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            if (size(el1%split_desc) == size(el2%split_desc)) then
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               do i = 1, size(el1%split_desc)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  if (el1%split_desc(i) /= el2%split_desc(i)) then
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     res = el1%split_desc(i) < el2%split_desc(i)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     exit
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  end if
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               end do
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            end if
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         end function
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! =========== creation / destruction ========
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief allocates and initializes a single linked list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the single linked list to initialize
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param first_el the first element of this list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param rest the following elements (if not given: empty)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_create(sll, first_el, rest)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER, OPTIONAL :: first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER, OPTIONAL :: rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (.NOT. PRESENT(first_el)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               NULLIFY (sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (PRESENT(rest)) sll => rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ALLOCATE (sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               sll%first_el =>first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               NULLIFY (sll%rest)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (PRESENT(rest)) sll%rest => rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_create
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief deallocates the singly linked list starting at sll.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      Does not work if loops are present!
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list to be deallocated
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      does not deallocate the elements that are stored in the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      check more?
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_dealloc(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            CALL cp_sll_xc_deriv_rm_all_el(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_dealloc
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! * low-level *
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief deallocates a node of a singly linked list (low level)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the node to be deallocated
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_dealloc_node(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            DEALLOCATE (sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_dealloc_node
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! ============= get/set ============
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns the first element stored in the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the single linked list to get the element from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_get_first_el(sll) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            res =>sll%first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_get_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns the rest of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the single linked list to get the rest from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param iter how many times the call to rest should be iterated,
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>            defaults to 1; -1 means till end of the list.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      split the case iter=1 to make it more optimized?
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_get_rest(sll, iter) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER, OPTIONAL :: iter
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER :: i
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (.NOT. ASSOCIATED(sll)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               NULLIFY (res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (PRESENT(iter)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  res => sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  DO i = 1, iter
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     IF (ASSOCIATED(res%rest)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                        res => res%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                        CPABORT("tried to go past end")
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  END DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  IF (iter == -1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                        IF (.NOT. ASSOCIATED(res%rest)) EXIT
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                        res => res%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                     END DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  res => sll%rest ! make the common case fast...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_get_rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns the length of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list you want to know the length of
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      slow (O(n))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_get_length(sll) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), pointer :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER ::res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: iterator
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            res = 0
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            iterator => sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (ASSOCIATED(iterator)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  res = res + 1
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  iterator => iterator%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  EXIT
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_get_length
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns the element at the given index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list you get the element from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param index the position of the element (stating at 1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      slow (O(index))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_get_el_at(sll, index) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER, INTENT(in) :: index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: pos
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (index == -1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               pos => cp_sll_xc_deriv_get_rest(sll, iter=-1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               pos => cp_sll_xc_deriv_get_rest(sll, iter=index - 1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            CPASSERT(ASSOCIATED(pos))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            res =>pos%first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_get_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief sets the element at the given index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list you get the element from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param index the position of the element (stating at 1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>             -1 means at the end
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param value the new element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      slow (O(index))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_set_el_at(sll, index, value)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER :: value
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER, INTENT(in) :: index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: pos
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (index == -1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               pos => cp_sll_xc_deriv_get_rest(sll, iter=-1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               pos => cp_sll_xc_deriv_get_rest(sll, iter=index - 1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            CPASSERT(ASSOCIATED(pos))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            pos%first_el =>value
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_set_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! * iteration *
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns true if the actual element is valid (i.e. iterator ont at end)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      moves the iterator to the next element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param iterator iterator that moves along the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param el_att the actual element (valid only if the function returns true)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_next(iterator, el_att) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: iterator
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER, OPTIONAL :: el_att
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            LOGICAL :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (ASSOCIATED(iterator)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               res = .TRUE.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               if (present(el_att)) el_att =>iterator%first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               iterator => iterator%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               res = .FALSE.
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_next
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! ============ structure modifications ============
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief insert an element at the beginning of the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the single linked list point at the beginning of which
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>           you want to add the element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param el the element to add
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      fast (O(1))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_insert_el(sll, el)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER:: el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: newSlot
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            NULLIFY (newSlot)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            CALL cp_sll_xc_deriv_create(newSlot, first_el=el, &
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                                                rest=sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            sll => newSlot
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_insert_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief remove the first element of the linked list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list whose first element has to be removed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      fast (O(1))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_rm_first_el(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: node_to_rm
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            node_to_rm => sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (ASSOCIATED(sll)) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               sll => sll%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_dealloc_node(node_to_rm)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CPABORT("tried to remove first el of an empty list")
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_rm_first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief inserts the element at the given index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list you get the element from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param el the new element
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param index the position of the element (stating at 1).
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>             If it is -1, it means at end
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      slow (O(index))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_insert_el_at(sll, el, index)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(xc_derivative_type), POINTER :: el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER, INTENT(in) :: index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: pos
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (index == 1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_insert_el(sll, el)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (index == -1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  pos => cp_sll_xc_deriv_get_rest(sll, iter=-1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  pos => cp_sll_xc_deriv_get_rest(sll, iter=index - 2)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CPASSERT(ASSOCIATED(pos))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_insert_el(pos%rest, el)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_insert_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief removes the element at the given index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list you get the element from
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param index the position of the element (stating at 1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      slow (O(index))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_rm_el_at(sll, index)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER, INTENT(in)::index
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: pos
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            IF (index == 1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_rm_first_el(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (index == -1) THEN
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  pos => cp_sll_xc_deriv_get_rest(sll, iter=-1)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ELSE
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
                  pos => cp_sll_xc_deriv_get_rest(sll, iter=index - 2)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CPASSERT(ASSOCIATED(pos))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_rm_first_el(pos%rest)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END IF
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_rm_el_at
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief removes all the elements from the list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list that should be removed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      none
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \note
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      check more?
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         SUBROUTINE cp_sll_xc_deriv_rm_all_el(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: next_node, actual_node
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            actual_node => sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               IF (.NOT. ASSOCIATED(actual_node)) EXIT
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               next_node => actual_node%rest
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CALL cp_sll_xc_deriv_dealloc_node(actual_node)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               actual_node => next_node
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            NULLIFY (sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END SUBROUTINE cp_sll_xc_deriv_rm_all_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \brief returns a newly allocated array with the same contents as
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      the linked list
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \param sll the list to transform in array
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \return ...
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \par History
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!>      07.2002 created [fawzi]
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
!> \author Fawzi Mohamed
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
! **************************************************************************************************
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         FUNCTION cp_sll_xc_deriv_to_array(sll) RESULT(res)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            type(xc_derivative_p_type), DIMENSION(:), POINTER :: res
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            INTEGER :: len, i
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            LOGICAL :: ok
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            TYPE(cp_sll_xc_deriv_type), POINTER :: iter
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"

# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            len = cp_sll_xc_deriv_get_length(sll)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            ALLOCATE (res(len))
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            iter => sll
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            DO i = 1, len
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               res(i) %deriv=>iter%first_el
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               ok = cp_sll_xc_deriv_next(iter)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
               CPASSERT(ok .OR. i == len)
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
            END DO
# 53 "/builddir/build/BUILD/cp2k-2023.1/src/xc/cp_linked_list_xc_deriv.F"
         END FUNCTION cp_sll_xc_deriv_to_array
END MODULE
